/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2013-2014 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of the GNU General
 * Public License Version 2 only ("GPL"). You may not use this file except
 * in compliance with the License.  You can obtain a copy of the License at
 * https://avatar.java.net/license.html or legal/LICENSE.txt.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at legal/LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 */

/*
 * Implementation of CDI API. This API supports injection of Java objects
 * into JS.
 *
 * @module org/glassfish/avatar/cdi
 */

'use strict';

var common = require('org/glassfish/avatar/common');
var Promise = common.Promise;
var wrapCallback = common.wrapCallback;
var System = Java.type('java.lang.System');
var when = require('when');

var CdiHelper = Java.type('org.glassfish.avatar.runtime.service.cdi.CdiHelper');
var cdiHelper = new CdiHelper();

exports.inject = function(nameOrClass) {
    var name;
    if (typeof nameOrClass !== "string") {
        name = nameOrClass.getClass();      // does not work!
    } else {
        name = nameOrClass;
    }
    return cdiHelper.inject(name);
};
