<?xml version="1.0" encoding="US-ASCII"?>
<!--

    DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.

    Copyright (c) 2013 Oracle and/or its affiliates. All rights reserved.

    The contents of this file are subject to the terms of the GNU General
    Public License Version 2 only ("GPL"). You may not use this file except
    in compliance with the License.  You can obtain a copy of the License at
    https://avatar.java.net/license.html or legal/LICENSE.txt.  See the
    License for the specific language governing permissions and limitations
    under the License.

    When distributing the software, include this License Header Notice in each
    file and include the License file at legal/LICENSE.txt.

    GPL Classpath Exception:
    Oracle designates this particular file as subject to the "Classpath"
    exception as provided by Oracle in the GPL Version 2 section of the License
    file that accompanied this code.

    Modifications:
    If applicable, add the following below the License Header, with the fields
    enclosed by brackets [] replaced by your own identifying information:
    "Portions Copyright [year] [name of copyright owner]"

-->

<!--
  - Generator for Model Library
  - @author spericas@java.net
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
                xmlns:a="http://www.glassfish.org/avatar">

    <xsl:param name="common" select="'common-jquery.xml'"/>
    <xsl:param name="widgetLib" select="'jquery'"/>
    
    <xsl:output method="text" indent="no"/>

    <xsl:template match="/">
        <xsl:text>
    /*
     * Project Avatar Model Library: GENERATED CODE -- DO NOT EDIT
     */
        </xsl:text>
        <xsl:choose>
            <xsl:when test="$widgetLib = 'jquery'">
                <xsl:text>
    define("org/glassfish/avatar/model", ['jquery'],
        function($) {
                </xsl:text>
            </xsl:when>
            <xsl:when test="$widgetLib = 'dojo'">
                <xsl:text>
    define("org/glassfish/avatar/model", ['dojo'],
        function(dojo) {
                </xsl:text>
            </xsl:when>
            <xsl:otherwise>
                <xsl:message terminate="yes">Unknown value for 'widgetLib'</xsl:message>
            </xsl:otherwise>
        </xsl:choose>

        <xsl:text>
            /**
             * @module org/glassfish/avatar/models
             */
            var exports = {
                constructors: []
            };
        </xsl:text>
        <xsl:apply-templates select="document($common)" mode="xhr"/>
        <xsl:apply-templates/>
        <xsl:call-template name="genFunctions"/>
        <xsl:text>
            return exports;
        });
        </xsl:text>
    </xsl:template>

    <xsl:template match="a:definition">
        <xsl:value-of select="*[last()]/text()"/>
    </xsl:template>

    <xsl:template match="a:definition[starts-with(@id, 'xhr')]" mode="xhr">
        <xsl:value-of select="*[last()]/text()"/>
    </xsl:template>

    <xsl:template name="genFunctions">
        <xsl:text>
            /**
             * Registers a constructor as a local model.
             *
             * @param {string} type Model type name.
             * @param {function} constructor Constructor function for model.
             */
            exports.localModel = function(type, constructor) {
                constructor.prototype = localModelBase;
                exports.constructors[type] = constructor;
            };
        </xsl:text>
        <xsl:text>
            /**
             * Registers a constructor as a rest model.
             *
             * @param {string} type Model type name.
             * @param {function} constructor Constructor function for model.
             */
            exports.restModel = function(type, constructor) {
                constructor.prototype = restModelBase;
                exports.constructors[type] = constructor;
            };
        </xsl:text>
        <xsl:text>
            /**
             * Registers a constructor as a push model.
             *
             * @param {string} type Model type name.
             * @param {function} constructor Constructor function for model.
             */
            exports.pushModel = function(type, constructor) {
                constructor.prototype = pushModelBase;
                exports.constructors[type] = constructor;
            };
        </xsl:text>
        <xsl:text>
            /**
             * Registers a constructor as a socket model.
             *
             * @param {string} type Model type name.
             * @param {function} constructor Constructor function for model.
             */
            exports.socketModel = function(type, constructor) {
                constructor.prototype = socketModelBase;
                exports.constructors[type] = constructor;
            };
        </xsl:text>
        <xsl:text>
            /**
             * Creates an instance of a model given model type name and
             * any parameters needed to initialize the instance.
             *
             * @param {string} type Model type name.
             * @param {object} params Parameters used to initialize model instance.
             */
            exports.newModel = function(type, params) {
                var nextId = 0;
                function generateId(prefix) {
                    return prefix + (nextId++);
                }

                if (!params) {
                    params = { };
                }
                params.idref = exports.constructors[type];
                params.id = type || generateId("model");
                return newModel(params);
            };
        </xsl:text>
    </xsl:template>

    <xsl:template match="comment()">
        <xsl:copy/>
    </xsl:template>

    <xsl:template match="text()">
    </xsl:template>

    <xsl:template match="comment()" mode="xhr">
        <xsl:copy/>
    </xsl:template>

    <xsl:template match="text()" mode="xhr">
    </xsl:template>

</xsl:stylesheet>
